// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Device;
use crate::MonitorIter;
use glib::object::ObjectType as ObjectType_;
use glib::signal::connect_raw;
use glib::signal::SignalHandlerId;
use glib::translate::*;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;

glib::wrapper! {
    #[doc(alias = "ManetteMonitor")]
    pub struct Monitor(Object<ffi::ManetteMonitor, ffi::ManetteMonitorClass>);

    match fn {
        type_ => || ffi::manette_monitor_get_type(),
    }
}

impl Monitor {
    #[doc(alias = "manette_monitor_new")]
    pub fn new() -> Monitor {
        unsafe { from_glib_full(ffi::manette_monitor_new()) }
    }

    #[doc(alias = "manette_monitor_iterate")]
    pub fn iterate(&self) -> MonitorIter {
        unsafe { from_glib_full(ffi::manette_monitor_iterate(self.to_glib_none().0)) }
    }

    #[doc(alias = "device-connected")]
    pub fn connect_device_connected<F: Fn(&Self, &Device) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn device_connected_trampoline<F: Fn(&Monitor, &Device) + 'static>(
            this: *mut ffi::ManetteMonitor,
            device: *mut ffi::ManetteDevice,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this), &from_glib_borrow(device))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"device-connected\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    device_connected_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "device-disconnected")]
    pub fn connect_device_disconnected<F: Fn(&Self, &Device) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn device_disconnected_trampoline<F: Fn(&Monitor, &Device) + 'static>(
            this: *mut ffi::ManetteMonitor,
            device: *mut ffi::ManetteDevice,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this), &from_glib_borrow(device))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"device-disconnected\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    device_disconnected_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for Monitor {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for Monitor {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Monitor")
    }
}
